/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Departemen;
import com.portofolio.entity.vo.DepartemenId;

@Lazy
@Repository("departemenDao")
public interface DepartemenDao extends CrudRepository<Departemen, DepartemenId> {
    

    @Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.namaDepartemen like %:namaDepartemen% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaDepartemen") String namaDepartemen, @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and model.id.kdDepartemen = :kdDepartemen")
    Map<String, Object> findByKdDepartemen(@Param("kdProfile") Integer kdProfile, @Param("kdDepartemen") String kdDepartemen,@Param("statusEnabled") boolean statusEnabled);
       
    
    String QListAll ="select new map(pegawai.id.kdPegawai as kdPegawaiKepala,pegawai.namaLengkap as namaLengkapPegawaiKepala,model.id.kdDepartemen as kdDepartemen,model.id.kdProfile as kdProfile "
            + ", model.namaDepartemen as namaDepartemen " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kdDepartemenHead as kdDepartemenHead "
            + ", departemenHead.namaDepartemen as namaDepartemenHead" 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec, model.version as version )" 
            + " from Departemen model left join model.id id"
            + " left join model.pegawaiKepala pegawai "
            + "left join model.departemenHead departemenHead "
            + "where id.kdProfile=:kdProfile and model.statusEnabled=:statusEnabled ";
  
	    
}
